package org.greenstone.gsdl3.gs3build.xpointer;

import org.w3c.dom.*;
import org.apache.xpath.*;

public class RangeToXPointer extends XPointer
{
  public static final String RANGE_TO = "range-to(";
  NodeList startNodes;
  NodeList endNodes;

  public RangeToXPointer(Document document, String xpointer)
  { super(document, xpointer);

    String fromPointer, toPointer;

    int rangeAt = xpointer.indexOf(RANGE_TO);

    fromPointer = xpointer.substring(0, rangeAt-1);
    toPointer = xpointer.substring(rangeAt+RANGE_TO.length(), xpointer.length()-1);

    fromPointer = XPointer.expandXPath(fromPointer);
    toPointer   = XPointer.expandXPath(toPointer);
    //    System.out.println(fromPointer + " " + toPointer);
    
    this.startNodes = this.getNodes(fromPointer);
    this.endNodes = this.getNodes(toPointer);
    
    //    System.out.println(this.startNodes.item(0).toString() + " " + this.endNodes.item(0).toString());
  }

  public Node getStartNode()
  { return this.startNodes.item(0);
  }

  private NodeList getNodes(String pointer)
  {
    try {
      NodeList nodes = XPathAPI.selectNodeList(document, pointer, document.getDocumentElement());
      return nodes;
    }
    catch (Exception ex)
    { System.out.println(ex.toString());
    }
    return null;
  }

  private void recurseStringify(Node at, Node end, StringBuffer reply)
  {
    while (at != end && at != null) {
      this.printNode(at, reply, false);
      at = this.getNextNode(at, reply);
      //      System.out.println(at + " " + end);
    }
  }

  public String toString()
  { StringBuffer reply = new StringBuffer();

    // skip the first node
    Node firstNode = this.startNodes.item(0);
    firstNode = this.getNextNode(firstNode, reply);
    
    // actually, we don't, as otherwise the indexed copy of 
    // the document would be incomplete...
    this.recurseStringify(this.startNodes.item(0), this.endNodes.item(0), reply);
    return reply.toString();
  }
}
